/* ==== attackroll.c ==== */
/* just the attackroll function. Separate from everything else,
  to allow test-harnesses to be attached to it easily */
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */

short attackroll();

#if 1
#include "porrog_defs.h"
#include "dXrng.h"
#define D4() (roll_dX(d4set[0]))
#define D6() (roll_dX(d6set[0]))
#define D8() (roll_dX(d8set[0]))
#define D10() (roll_dX(d10set[0]))
#define D12() (roll_dX(d12set[0]))
#define D20() (roll_dX(d20set[0]))
#else
#define D4() (random()%4)
#define D6() (random()%6)
#define D8() (random()%8)
#define D10() (random()%10)
#define D12() (random()%12)
#define USE_D20(die) (tmp=die),(die=(die+1)%20),tmp
#define D20() (random()%20)
#endif

/* low-sample counts on this suggest around 75% numbers have magnitude
of 20 or less; around 10% (much less accurately) have magnitude of 50
or more. Some have magnitude of 100, or over 90.
This seems like a reasonable spread to me: a range of just +-10 or so
would have been good for showing up the differences between attacker
and defender; But it is still desirable that occasionally, the unlikely
should happen, which wouldn't be possible with such a low range. Using
2dx, or especially 3dx or 4dx, had the undesirable effect of far too
sharply concentrating results at 0.*/

short attackroll() {
   int tmp;
#ifdef OLDSEC
   static int sec_remap[10]={0,0,0,0,1, 1,1,2,2,3};
#else
   static int sec_remap[36]={0,0,0,0,0,0,  0,0,0,1,1,1,
                             1,1,1,1,1,2,  2,2,2,2,2,2,
                             3,3,3,3,3,3,  4,4,4,4,4,100};
#endif

/*   static int dir_remap[12]={0,0, 1,1, 1,1,1,-1,   -1,-1,-1,-1}; */
/*   static int dir_remap[20]={0,1,1,1,1,         1,1,1,1,1,
                          -1,-1,-1,-1,-1,    -1,-1,-1,-1,0}; */
   /* dir remap wants to make 0 less common! Or...*/
   /* dir will be done differently. */

#if 0
   static int main_remap[20]={-1,0,0,0,0,   0,1,1,1,1,
                              1,2,2,2,2,   3,3,3,999,999};
#else
   static int main_remap[48]={0,0,0,0,0,0,  0,0,0,1,1,1,
                              1,1,1,1,1,2,  2,2,2,2,2,2,
                              3,3,3,3,3,3,  4,4,4,4,4,999,
                              999,999,999,999,999,999,
                                  999,999,999,999,999,-1};
                             /* -1 means return 0; 999 means look further*/
#endif
/*   static int lsb_remap[8]={1,1,1,1, 1,2,2,2}; */
#if 1
   static int lsb_remap[24]={1,1,1,1,1,1,  1,2,2,2,2,2,
                             2,3,3,3,3,3,  3,4,4,4,4,4};
#else
   static int lsb_remap[12]={1,1,1,1, 2,2,2,2, 3,3,3,3};
   /* instead, just have flat LSB, don't remap it! */

#endif

   short dir,mainroll,secondary,bignum;
/*  dir=dir_remap[USE_D20(d0)];*/
   dir=2*((D8()%2)-0.5);
   if(dir==0) return (0);
   /* else dir determines sign of later values  */

   mainroll=main_remap[(D8()*6)+D6()];
   if(mainroll==-1) return(0);
   /* normally ==  0,1,2, or 3; */
   if(mainroll==999) { /* perverse cases. Do secondary roll. */

     /*  OLDSEC
     secondary=D10();
     return(dir*(21+(D20())+(20*sec_remap[secondary]))); */
     /* returns 21 to 100 */
     secondary=sec_remap[(6*D6())+D6()];
     if(secondary==100) return(dir*100); /* someone slipped up totally */
     bignum=(dir*(21+(2*D8())+(16*secondary)));
     return(bignum);
     /* returns 21 to 100 */
   } else

#if 0
   return(dir*((3*mainroll)+lsb_remap[D12()]));
#else
   return(dir*((4*mainroll)+D4()+1));
   /* returns 0 to 6 + 1 to 2, =1 to 8. */
#endif

}

