/* ==== combat.c ==== */
/* Uh... what'll we do here? */
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */

#include "porrog_defs.h"
#include "C-foogrid.h"
#include "item_t.h"
#include "crash.h"
#include "structures.h"
#include "mapgen_types.h"
#include "player_t.h"
#include "dXrng.h"
/* protos */
#include "monster.h"
#include "ui.h"
#include "item_p.h"
#include "los.h"
#include "player_p.h"
#include "race_p.h"
/* #include "combat.h" */
#include "attackroll.h"
#ifdef AUTOPILOT
#include   "mg_utils.h"
#endif


/* Don't need to state map any more ! */
void p_hit_m(monster_t *target)
{
    /* work out damage based on weapon */
    unsigned int dmg,plvl=player.Var_stats.Level;
    int tht,tev,roll;
    char nstring[80];
    item_t *weap=player.Equipment[EQUIP_WEAPON];
    dmg=global_scale_weapdmg(weap,player.Fixed_stats.Str,plvl);
    tht=global_scale_weaptht(weap,player.Fixed_stats.Dex,plvl);
    tev=global_scale_evasion(target->Fixed_stats.Agi,target->Var_stats.Level);
#ifdef COMBATSTATS
    sprintf(strbuf,"Your tohit: %d; target's evasion: %d.",tht,tev);
    show_messages(strbuf);
#endif

/*  roll=(roll_dX(d10set[0])+(10*roll_dX(d10set[1])))-23;  gives -23 to 76*/

    /* I think this should be more like 3d8-10, or even 4d8-14, or similar.
    This would mean that when tht and tev are close, it could easily go
    either way, but when they're far apart, it really makes a big difference.
    Perhaps at the end points of the roll (as in 3d8=3 and 3d8=24), allow
    a further roll of something to add on (or subtract), allowing for very
    very perverse luck, of the type that would allow a tht of 0 to hit a
    tev of 100. Or a tht of 100 to miss a tev of 0.
    I think I'll create an "attackroll()" function. */
    roll=attackroll()+1; /* odds in our favour */
#ifdef COMBATSTATS
    sprintf(strbuf,"Roll: %d.",roll);
    show_messages(strbuf);
#endif
    if(tht+roll>tev) { /* Hit */ 
#ifdef COMBATSTATS
       sprintf(strbuf,"Typ dmg: %d;",dmg);
       show_messages(strbuf);
#endif
       dmg=(dmg*(3+roll_dX(d6set[0])))/6;/*somewhere in range .5dmg to 1.3dmg*/
#ifdef COMBATSTATS
       sprintf(strbuf,"Actual dmg: %d.",dmg);
       show_messages(strbuf);
#endif
       if(dmg==0)dmg=1;
       target->Var_stats.Hp-=dmg;
       if(weap==NULL) {
         sprintf(strbuf,"You hit the %s.",target->Mobtype->Name);
       } else {
         item_basename(nstring,weap);
         sprintf(strbuf,"You hit the %s with your %s.",target->Mobtype->Name,nstring); 
       }
       show_messages(strbuf);
#ifdef COMBATSTATS
    sprintf(strbuf,"It has %d HP left!",target->Var_stats.Hp);
    show_messages(strbuf);
#endif
       if(target->Var_stats.Hp<0)
       {
          sprintf(strbuf,"You kill the %s!",target->Mobtype->Name);
          show_messages(strbuf);
   /*  p_gainexp(1+(4*target->Mobtype->BaseLevel)); */
          p_gainexp((global_scale_expreq(target->Mobtype->BaseLevel+1)/8)+1);
          /* Must have the monster die *after* accessing its data!
           Fixed for 0.06- I thought I'd already done this for 0.05b?! */
          m_die(tls,target); /* should be in monster.c */
       }
    } else {
       sprintf(strbuf,"You miss the %s.",target->Mobtype->Name);
       show_messages(strbuf);
    }
}

void m_hit_p(monster_t *attacker)
{
#ifdef AUTOPILOT
    int r;
#endif
    unsigned int dmg,mlvl=attacker->Var_stats.Level;
    int tpos,apos,acov, aprot,  tht,tev,roll;
    item_t *weap=NULL;/* TODO! monster has no equipment yet */
    item_t *aitem;
    char arname[80]; /*  name of armour */
    /* Originally, just assume attacker always hits, removing 1 HP */
    /* Haha! Now we've got more advanced view of combat. */
    /* First see if mob hits you. */
    dmg=global_scale_weapdmg(weap,attacker->Fixed_stats.Str,mlvl);
    tht=global_scale_weaptht(weap,attacker->Fixed_stats.Dex,mlvl);
    tev=global_scale_evasion(player.Fixed_stats.Agi,player.Var_stats.Level);
#ifdef COMBATSTATS
    sprintf(strbuf,"Attacker's tohit: %d; your evasion: %d.",tht,tev);
    show_messages(strbuf);
#endif
/*  roll=(roll_dX(d10set[0])+(10*roll_dX(d10set[1])))-29; -29 to 70 */
    roll=attackroll()-2;
#ifdef COMBATSTATS
    sprintf(strbuf,"Roll: %d.",roll);
    show_messages(strbuf);
#endif
    if (tht+roll<=tev) { /* haha, odds are in our favour */
       sprintf(strbuf,"The %s misses you.",attacker->Mobtype->Name);
       show_messages(strbuf);
       return; 
    }
#ifdef COMBATSTATS
    sprintf(strbuf,"Typ dmg: %d;",dmg);
    show_messages(strbuf);
#endif
    dmg=(dmg*(2+roll_dX(d6set[0])))/6; /* somewhere from .33dmg to 1.166 dmg */
    if(dmg==0)dmg=1;/* damage should only be 0 due to armour */
#ifdef COMBATSTATS
    sprintf(strbuf,"Actual dmg: %d.",dmg);
    show_messages(strbuf);
#endif
    /* The mob has hit. Does it hit your armour or *you*? */
    tpos=(10*roll_dX(d10set[0]))+roll_dX(d10set[1]);
    if (tpos<(player.Var_stats.Cov)) { /* hit armour */
       /* Work out *what* it hit... */
       for(apos=EQUIP_SUIT;apos!=EQUIP_NONE;tpos-=acov,apos++,apos=((apos==EQUIP_RING1)?EQUIP_NECKWEAR:apos))
       {
          /* find coverage of this item */
          aitem=player.Equipment[apos];
          if(aitem==NULL) {acov=0; continue;}
          acov=aitem->Itemtype->Typedata.Arm.Cov;
          if(tpos<acov) break; /* This is the item blocking */
       }
       if (apos==EQUIP_NONE) crash(FUNCTION_ERROR);
       aprot=aitem->Itemtype->Typedata.Arm.Prot;
       item_basename(arname,aitem);
  /*   describe_item(arname,aitem); Actually, the plain name's fine here */
       if (aprot>=dmg) { /* Damage nullified */
          sprintf(strbuf,"The %s hits you, but your %s completely blocks it.",attacker->Mobtype->Name,arname);
          dmg=0;
       } else { /* Reduced the damage */
          sprintf(strbuf,"The %s hits you (your %s absorbs some of the blow).",attacker->Mobtype->Name,arname);
          dmg-=aprot;
       }
    } else { /* bypasses armour */
       sprintf(strbuf,"The %s hits you.",attacker->Mobtype->Name);
    }
/* player.Var_stats.Hp-=((roll_dX(d6set[0])*(100-player.Var_stats.Cov))/200);*/
    player.Var_stats.Hp-=dmg;
    show_messages(strbuf);
    if(player.Var_stats.Hp<0)
    {
#ifndef AUTOPILOT
       sprintf(strbuf,"The %s kills you!",attacker->Mobtype->Name);
       show_messages(strbuf);
       quit=2; /* 2=dead */
#else
       /* Don't quit, just put the player somewhere else instead */
       player.Var_stats.Hp=player.Var_stats.MaxHp;
       r=pick_room(tls->Totalrooms);
       player.X=tls->Room[r].Xcentre;
       player.Y=tls->Room[r].Ycentre;
#endif
    }
}

void m_hit_m(monster_t *att, monster_t *target)
{
    /* FIXME!!! */
    unsigned int dmg,alvl=att->Var_stats.Level,tlvl=target->Var_stats.Level;
    int tht,tev,roll;
    int avis,tvis; /* visibility of attacker and target */
    item_t *weap=NULL; /* No monster equipment yet*/
    /* For now, we just assume monster always hits
    and removes 1 HP from target */
    dmg=global_scale_weapdmg(weap,att->Fixed_stats.Str,alvl);
    tht=global_scale_weaptht(weap,att->Fixed_stats.Dex,alvl);
    tev=global_scale_evasion(target->Fixed_stats.Agi,tlvl);
    /* don't give combatstats */
    roll=attackroll();
#ifndef AUTOPILOT
    avis= (in_los(player.X,player.Y,att->X,att->Y));
    tvis= (in_los(player.X,player.Y,target->X,target->Y));
#else
    avis= (in_los(tls->Moblist->X,tls->Moblist->Y,att->X,att->Y));
    tvis= (in_los(tls->Moblist->X,tls->Moblist->Y,target->X,target->Y));
#endif

    if(tht+roll<tev) {
      if(avis&&tvis) {
        sprintf(strbuf,"The %s misses the %s.",att->Mobtype->Name,target->Mobtype->Name);
        show_messages(strbuf);
      }
      return;
    }
    /* So it hit then. */
    if(avis&&tvis) {
      sprintf(strbuf,"The %s hits the %s.",att->Mobtype->Name,target->Mobtype->Name);
      show_messages(strbuf);
    }
    /* We don't take monster armour into account yet, as they don't have
    any whilst I'm writing this... */
    target->Var_stats.Hp-=dmg;
    if(target->Var_stats.Hp<0)
    {
       if (avis &&tvis) {
         sprintf(strbuf,"The %s kills the %s!",att->Mobtype->Name,target->Mobtype->Name);
         /* Would be handy to log this for debug stuff */
         show_messages(strbuf);
       }
       m_gainexp(att,(global_scale_expreq(target->Mobtype->BaseLevel+1)/8)+1);
       /* needs tweaking just like the player's experience gains */
       m_die(tls,target);
    }
}

/* makes a roll that is somewhere in range -100 to +100, but tends to
stay around 0. Doesn't apply any bias either way, caller should do this
itself. Perverse cases will happen the same amount one way or the other,
so the bias will only make a certain amount of difference to the
general cases. */

/* NOW IS IN attackroll.c, TO EASE FITTING INTO TEST HARNESS PROGRAM */
#if 0
short attackroll()
{
    /* THOUGHTS: For mainroll, 3d8 has the problem of being uneven;
    d100 had the clear problem of being flat and therefore made the
    game completely random- when the tht and tev were say 10 apart,
    it made very little difference which was better;
    but 4d8 had the problem of being too high at the middle- it was
    scarcely random at all (it always seemed more like tht>tev rather
    than tht+roll>tev).
    Now, I'm thinking 2d12-11: Not uneven, not flat, but certainly
    not too concentrated at the middle. */
    static int sec_remap[10]={0,0,0,0,1, 1,1,2,2,3}; /*remapping function */
    short mainroll;
    short secondary;/* to allow high range freak cases */

    mainroll=roll_dX(d12set[0])+roll_dX(d12set[1]);
    /* mainroll is in range 0 to 22 */
#define SHARPOFFSET 32
#define MEDOFFSET 12
    switch(mainroll) {
       case 0:
         secondary=roll_dX(d10set[0]);
         /* map this to 00001 11223, do *20, add 20+d20.
         return (-11 -that)*/
         return(-(SHARPOFFSET+roll_dX(d20set[0])+(20*sec_remap[secondary])));
         break;
       case 1: /* Slightly more common */ 
         secondary=roll_dX(d10set[0]);
         /* map this to 00001 11223, do *20, add d20.
         return -(11+that)*/
         return(-(MEDOFFSET+roll_dX(d20set[0])+(20*sec_remap[secondary])));
         break;

       case 21:
         secondary=roll_dX(d10set[0]);
         return(MEDOFFSET+roll_dX(d20set[0])+(20*sec_remap[secondary]));
         break;

       case 22:
         secondary=roll_dX(d10set[0]);
         return(SHARPOFFSET+roll_dX(d20set[0])+(20*sec_remap[secondary]));
         break;
       default:
         return(mainroll-11);
    }
    return(0); /* silence gcc */
}
#endif
