/* ==== help.c ==== */
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */


/* I've only just decided on the help format(s) now */


#include <string.h>
#include <stdio.h>
#include <stdlib.h> /* for malloc, free */
#include "syscurses.h"
#include "porrog_defs.h"

/* protos */
/* #include "memutils.h" Not now? */
#include "crash.h"
#include "help.h"

WINDOW *win;

void help_main()
{
   win=newwin(22,78,1,1);
   show_help("contents");
   werase(win);wrefresh(win); delwin(win);
   touchwin(stdscr);refresh();
}

void show_help(char *section) /* section must be proper format. */
{
    /* This is now just a wrapper that works out which file to get,
    what type it is, and calls the appropriate function for the format */
    FILE *fp;
    int is_ifo;
    char dname[30];
    char fname[35];
    if (strchr(section,'/')==NULL) {
      sprintf(dname,"help/%s",section);
      section=dname;
    }

    werase(win);
  /*  wmove(win,0,1);whline(win,'-',76);
    wmove(win,21,1);whline(win,'-',76); */
    if(strchr(section,'.')!=NULL) { /* Has some extension */
      if   (0==strcmp(strrchr(section,'.'),".ifo"))   is_ifo=1;
      else if(0==strcmp(strrchr(section,'.'),".cts")) is_ifo=0;
      else {display_bad_help_page(); return;}
      fp=fopen(section,"r");
      if(fp==NULL) {display_bad_help_page();return;}
      if(is_ifo) help_load_ifo(fp);
      else help_load_cts(fp);
      fclose(fp);

    } else { /* No extension given, use trial and error */

      fp=fopen((sprintf(fname,"%s.ifo",section),fname),"r");
      if (fp!=NULL) help_load_ifo(fp);
      else {
         fp=fopen((sprintf(fname,"%s.cts",section),fname),"r");
         if(fp!=NULL) help_load_cts(fp);
         else {display_bad_help_page(); return;}
      }
      fclose(fp);
    }
    /* Now we return */
    werase(win);
}


/* Not used now */
/*
{
    sprintf(fname,"%s.ifo",section);
    fp=fopen(fname,"r");

    fscanf(fp,"%c%c",&a,&b);
    fsize=(256*a)+b;
    farray=(char *)counting_malloc(MEM_STRING,fsize*sizeof(char));
    for(count=0;count<fsize;count++)
      *(farray+count)=getc(fp);


    counting_free(MEM_STRING,farray);
} */

/* .cts parser: */

void help_load_cts(FILE *hfile /* char *ctsname*/)
{
  /* Load in a cts file */
#define CR '\r'
#define LF '\n'
  /* FILE *hfile; */
  char *line[20]; /* text to be shown on each line */
  int menuline[20]; /* row number that each menu item is shown on (can have
                      a screen of only menu items) */
  char *secfile[20]; /* filename of section accessed from each menu item */
  char parsebuf[80]; /* 76 chars + line type ?: + newline + /0 */
  char *sptr;
  int l=0; /* line of the screen we're working on */
  int y; /* Used after parsing */
  int m=0; /* menu item we're working on */
  int t; /* character being read */
  int c; /* index into buffer */
  int indent,something; /* Not actually used yet */
  int haveline=1;
  int running=1,do_refresh;
  int faulty=0;
  int state=0; /* 0: just started;
      1: have read C line, not parsing menu item;
      2: parsing D line, expecting more D lines or an L line;
      3: Cack. */
  /* Parse the thing */
/*  hfile=fopen(ctsname,"r");
    if (hfile==NULL) {faulty=1;haveline=0;} */
  while (haveline) {
     t=getc(hfile);
     switch(t) {
        case CR: /* ignore this */
        case LF:
           break;
        case EOF:
           haveline=0;
           break;
        case '#': /* comment, read till newline */
           while(t=getc(hfile),(t!=CR&&t!=LF&&t!=EOF));
           break;
        case 'C':
           if(state!=0) {faulty=1;break;}
           if(getc(hfile)!=':') {faulty=1;break;}
           for(c=0;c<80;c++) {
              t=getc(hfile);
              if(t==EOF) {faulty=1;break;}
               /* *Could* call that valid, but its so stupid */
              if(t==CR||t==LF) {parsebuf[c]=0; break;}
              else parsebuf[c]=t;
           }
           if(c==80) {faulty=1;break;}
           sscanf(parsebuf,"%d %d",&indent,&something);
           state=1;
           break;
        case 'H':
           if(state==0||state==2) {faulty=1;break;}
           if(getc(hfile)!=':') {faulty=1;break;}
           for(c=0;c<76;c++) {
              t=getc(hfile);
              if(t==EOF||t==CR||t==LF) {parsebuf[c]=0;break;}
              else parsebuf[c]=t;
           }
           if(c==76) {faulty=1;break;}
           line[l]=(char *)malloc(c+1);
           strcpy(line[l],parsebuf);
           l++;/* don't change state */
           break;
        case 'D':
           if(state==0) {faulty=1;break;}
           if(getc(hfile)!=':') {faulty=1;break;}
           for(c=0;c<60;c++) {
              t=getc(hfile);
              if(t==EOF) {faulty=1;break;} /* D lines MUST precede L lines */
              if(t==CR||t==LF) {parsebuf[c]=0;break;}
              else parsebuf[c]=t;
           }
           if(c==60) {faulty=1;break;}
           line[l]=(char *)malloc(c+3);
           sprintf(line[l],"  ");
           strcpy(line[l]+2,parsebuf);
           if (state!=2) menuline[m]=l; /* point to this menu item; */
           /* update m when we get the L line */
           l++; state=2;
           break;
        case 'L':
           if(state!=2) {faulty=1;break;} /* L can only follow D */
           if(getc(hfile)!=':') {faulty=1;break;}
           for(c=0;c<20;c++) {
              t=getc(hfile);
              if(t==EOF||t==CR||t==LF) {parsebuf[c]=0;break;}
              else parsebuf[c]=t;
           }
           if(c==20) {faulty=1;break;}
           /* Now check it's a reasonable file:
           if it has a . in it, then only ifo or cts may follow that. */
           if(strrchr(parsebuf,'.')!=NULL) {
               /* Has a . so make sure the extension's valid */
               sptr=strrchr(parsebuf,'.');
               if(sptr!=NULL&&strcmp(sptr,".ifo") &&
                  strcmp(sptr,".cts") ) {faulty=1;break;}
           }
           secfile[m]=(char *)malloc(c+1);
           strcpy(secfile[m],parsebuf);
           m++;state=1;
           break;
        default:
           faulty=1;
     }
     if(l>20) faulty=1; /* Too many lines */
     if(faulty) haveline=0;
     if(feof(hfile)) haveline=0;
  }
  /* fclose(hfile); */
  if(faulty) {
     display_bad_help_page(); /* Let the user know the page is crap*/
     goto endcts;
  }

  c=0; /* Set cursor line */
  while(running) {
  help_draw_frame();
  for(y=0;y<l;y++) {
     wmove(win,y+1,1);waddstr(win,line[y]);
  }
  do_refresh=0;
  if(0==m) { /* NO menu items? Freak case, but... */
     touchwin(win);wrefresh(win);
     while(t=getch(),(t!=' '&&t!='h'));
     goto endcts;
  }
  while (!do_refresh) {
     /* wcolor_set(win,COLO:R_BLUE+1,NULL); */
     wsetpcolour(win,PCOL_DBLUE);
     wmove(win,1+menuline[c],1);waddch(win,'>');
     wmove(win,1+menuline[c],1);
     /* wcolor_set(win,0,NULL); -* white text. Was *8* for some reason?! */
     wsetpcolour(win,PCOL_DWHITE);
     touchwin(win);wrefresh(win);
     t=getch();
     switch(t) {
        case 'k':
           if(c>0) {wmove(win,1+menuline[c],1);waddch(win,' ');c--;}
           break;
        case 'j':
           if(c<m-1) {wmove(win,1+menuline[c],1);waddch(win,' ');c++;}
           break;
        case 'l':
        case CR:
        case LF:
           show_help(secfile[c]);
           do_refresh=1;
           break;
        case '?': /* ADDED AUG 5th 2004 for META-HELP! */
           show_help("usehelp.ifo"); /* should it have path? */
           do_refresh=1;
           break;
        case ' ':
        case 'h':
           goto endcts;
        default:;
     }
  }
  }
  /* Now clean up. */
  endcts:
  for(y=0;y<l;y++) free(line[y]);
  for(y=0;y<m;y++) free(secfile[y]);
  /* now we can return */
  werase(win);wrefresh(win);
}

void help_load_ifo(FILE *hfile)
{
   char *line[400];
   char lbuffer[80]; /* read in whilst getting line length */
   int c;
   int l=0;
   int i=0;
   int t,k;
   int y=1;
   for(c=0;c<80;c++) if(t=getc(hfile),EOF==t||CR==t||LF==t) break;
   while(y) {
     for(c=0;c<80;c++) {
        t=getc(hfile);
        if(EOF==t) {lbuffer[c]=0;y=0;break;}
        if(CR==t||LF==t)  {lbuffer[c]=0;break;}
        lbuffer[c]=t;
     }
     if(c>75) {display_bad_help_page(); goto endifo;}
     line[l]=(char *)malloc(c+1);
     strcpy(line[l],lbuffer);
     l++;
   }

   help_draw_frame();
   do {
      for(y=0;y<20&&y+i<l;y++) {
        wmove(win,y+1,1); /* waddch(win,'|'); */
        if(line[y+i]!=NULL) waddstr(win,line[y+i]);
        wclrtoeol(win);
        /* wcolor_set(win,COLO:R_RED+1,NULL); */
        wsetpcolour(win,PCOL_DRED);
        wmove(win,y+1,77);waddch(win,'|');/* wcolor_set(win,0,NULL);
        -* colour 0==white text, had said 8?? */
        wsetpcolour(win,PCOL_DWHITE);
      }
      touchwin(win);wrefresh(win);
      k=getch();
      switch(k) {
         case 'k':
           if(i>0) i--;
           break;
         case 'K':
           if(i>10) i-=10;
           else i=0;
           break;
         case 'j':
           if(i<l-20) i++;
           break;
         case 'J':
           if(i<l-30) i+=10;
           else i=(l-20);
           break;
         default:;
      }
      /*
      if('k'==k &&i>0) i--;
      if('j'==k &&i+20<l) i++; */
   } while (' '!=k&&'h'!=k);

   /* --- */
   endifo:
   for(y=0;y<l;y++) free(line[y]);
}

void display_bad_help_page()
{
   help_draw_frame();
   wmove(win,8,37-24);
   waddstr(win,"The requested help file is either bad or missing.");
   wmove(win,10,37-20);
   waddstr(win,"Press <SPACE> to return to previous page.");
   touchwin(win);wrefresh(win);
   while(' '!=getch());
   /* should clean up now */
   werase(win);wrefresh(win);
}

/* Not needed any more? 
void format_help(char *section) */

void help_draw_frame()
{
   /* wcolor_set(win,COLO:R_RED+1,NULL); */
   wsetpcolour(win,PCOL_DRED);
   wmove(win,0,0);waddch(win,'+');whline(win,'-',76);
   wmove(win,21,0);waddch(win,'+');whline(win,'-',76);
   wmove(win,1,0);wvline(win,'|',20);
   wmove(win,0,77);waddch(win,'+');wmove(win,1,77);wvline(win,'|',20);
   wmove(win,21,77);waddch(win,'+');
   /* wcolor_set(win,0,NULL); -* 0==white, had said 8 */
   wsetpcolour(win,PCOL_DWHITE);

}
/* --- end of help.c --- */

