/* ==== hlm.c ==== */
/* High-level map organisation type thingy */

/* So we put a wilderness map at the top level;
 Lots of dungeons should be connected under that (but at first, just
 the one).
 Each dungeon should (possibly) only have one set of stairs up at
 the very top, but should have relatively complicated internals
 as described int NOTES/Tunnels4 */

/* Um, how do we do this? Various approaches:
  -At init, create all the overall world structure, like the overall structure
   of how each level of every dungeon fits together, but don't create
   any of the levels themselves
  -When you first enter any level, work out how it fits with previous levels
   based on the algo here
  -For each dungeon you enter, work out the whole thing at once


  -Work out overall structures down to a certain depth for each dungeon,
  and each time we try to make a map, make 2 or 3, and use some of them
  to fit onto appropriate multi-area levels anywhere in any of the dungeons.
  Why? Because trying to generate a 3 area map might give you 1 or 2 areas
  instead, it's hard to guarantee. So we try to generate them ahead of
  time. */

/* We get a structure, that may get rolled into other onesm etcm that
has a char array of ~10 bytes. It IS NOT interpreted as a string!!
Each position in the array represents (potential) staircase, The
structure also has an array of... 5? elements describing each potential
AREA in the map. One part of that data describes the index of the
FIRST staircase in the area. Another part describes the difficulty
(the figure calulated from the distance from the surface. That figure
is used to calculate level for monsters, and to help calulate high-level
structural stuff */
