/* ==== crash.h ==== */
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */


/* What flags we want to watch. Should be set from command-line options */
extern unsigned short watchflags;

extern char *bugger_ringbuffer[]; /* our buglog */
extern unsigned short brb_startidx;
extern unsigned short brb_endidx;


enum crashtype {
    NO_MEM,
    INVALID_DIE_TYPE,
    INVALID_ENVIRONMENT,
    IO_ERROR,
    SCREEN_ERROR,
    INCONSISTENT, /*Some earlier screw up means we have no good response*/
    FUNCTION_ERROR, /* A *specific* function has misfired */
    OUT_OF_BOUNDS
};

void crash(enum crashtype reason);

/* AND some of these flag types together to get the "flags" argument
 to the function bugger()  below; there they specify what the report
 is pertinent to. At the start of the game, or some such time, you
 use a similar combination to express what reports should be logged
 if they're not serious. */
#define REPTYPE_MAPGEN   0x0001
#define REPTYPE_AI       0x0002
#define REPTYPE_ITEMS    0x0004
#define REPTYPE_EQUIP    0x0008
#define REPTYPE_MONSTERS 0x0010
#define REPTYPE_COMBAT   0x0020
#define REPTYPE_CODE     0x0040
  /* Used when a function's caller should have done something differently */
#define REPTYPE_FILE     0x0080
  /* used when anything is wrong with a file, possibly including the
  code processing it wrongly?? */

/* Created because using show_messages to log debug info, and using
 crash() to bring attention to serious but non-lethal errors really sucks.
 Like show_messages(), this should log the messages to a big ring-buffer.
 Unlike show_messages(), i shouldn't display them (if the severity is high,
 it should indicate that, but not give details). */
void bugger(unsigned short flags, buglevel_t severity, char *bug);

/* Dump our buglogs ringbuffer to a file (usu called when game ends) */
void dump_buglog();

void free_buglog();

/* --- yay! --- */
