/* ==== dungeon_p.h ==== */
/* prototypes for dungeon manipulation functions */
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */


/* used for finding features for player to interact wih such as doors or
traps, etc) */
direction_t checkForTile(int x,int y,tile_t target_tile,int consider_here);
/* scan 3x3 area centred around (x,y) for one of a given type of tile; only
count tiles found in centre square if "consider_here" is set. If none are
found, return FACE_NONE; if more than one, return FACE_ERROR (but it *isn't*
an error!!); otherwise, return corresponding direction for position of tile*/

#define FACING_TO_X(dir) (((dir)==FACE_E||(dir)==FACE_NE||(dir)==FACE_SE) \
                         -((dir)==FACE_W||(dir)==FACE_NW||(dir)==FACE_SW))
#define FACING_TO_Y(dir) (((dir)==FACE_S||(dir)==FACE_SW||(dir)==FACE_SE) \
                         -((dir)==FACE_N||(dir)==FACE_NW||(dir)==FACE_NE))

/* may create some function to work out reasons a door would be
 unopenable (0 meaning NOT unopenable, some values to mean not
 applicable (no door), some values to mean stuck, etc. Ditto
 for closableness... Ah- here we are! */
int isUnopenable(int x,int y);
/* true if unopenable. Truth value describes WHY unopenable:
1-not a door! 2-already open; 3-locked; 4-stuck */

int isUncloseable(int x,int y);
/* true if uncloseable. Truth value describes WHY uncloseable:
1-not a door; 2-already closed; 3-blocked; 4-stuck */

void open_door(int x, int y);
/* opens door. Must be an openable door there! */

void close_door(int x, int y);
/* closes door. Must be a closable door there! */

