/* ==== player_t.h ==== */
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */

/* This one is now just the player's structure */
/* All these are adapted from monster.h */

typedef struct {
   int X,Y;
   levelmap_t *Map; /* What map we're on! */
   char Symbol;
   int Ticker; /* incremented when player acts, decremented as
      time passes. When 0 or lower, player can act again */
   item_t *Inventlist;
   item_t *Inventend; /* pointer to last item (if any) or NULL.
      If only one item, it's that one, This SHOULD only be used by
      p_get_item(); if it finds Inventend==NULL, add to Inventlist
      instead. Perhaps similar thing should be added to containers?
      Or not.
      AH. p_discard_item() will also need to work with this value,
      but only some of the time. Unfortunately, it will then need
      to know its predecessor, which won't be stored.
      HOWEVER, p_discard_item() ALWAYS goes through the inventory
      list to find an item's predecessor, so that's no problem... */
   item_t *Equipment[10];
   /* Pointers to inventory items that are being used as:
   weapon, rangedweapon,
   suit, shield, headgear, gloves, footwear, 2 rings, necklace */
   var_stats_t Var_stats;
   training_t Training; /* How many points of "training" player has */
   fixed_stats_t Fixed_stats;
   /* Can't think of anything else */
   satiation_t SatiationStatus; /* only relevant to player */
} player_t;

extern player_t player;

extern int pstype;
extern region_t *psregion;
extern int psroomno;

extern int quit; /* Set when game stops, either because player dies,
   or because player quits, wins, or saves.
   Meanings: 1-quit  2-die  3-save  4-win  (0-dont quit) */
