/* ==== porrog_defs.h ==== */
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */


#include <stdint.h> /* for uint64_t */
#include "config.h" /* Settings for everything! */
#include "enums.h" /* Lets not bother asking everything
          to #include that separately */
typedef unsigned char byte;
/* USED TO be plain old char, but this is awkward! */

#define MIN(x,y) ((x<y)?x:y)
#define MAX(x,y) ((x>y)?x:y)
/* That's right, yes?*/

extern char *commonstring[]; /* defined in messages.c */

/* For stringifying the 64 bit ints (as used for experience) */
#if 0
/* This version uses an externally defined buffer. Best not used */
void u64toa(char buf[],uint64_t n);
#else
/* This version uses an internal, static buffer, and is overwritten each
time. Use *this* one unless we find a case where it would be bad. */
char *u64toa(uint64_t n) ;
#endif

int lastSpace(char *start, int length);
/* like a variation on strchr(), but finds the last occurrence of a space
 in the string, *before* "end", defined by start+length. */
/* URGH that definition was kind of wrong actually, see function in util.c
 for how it *really* behaves!! */

void sprintempty(char *string);
/* JUST like sprintf(string,"") but not done in that way and doesn't give
 annoying compiler errors ;) */

void stoupper(char *string);
/* Uppercases a string buffer. Returns nothing, acts directly on the arg. */

/* ---end of porrog_defs.h --- */
