/* ==== memutils.c ==== */
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */

#include <stdlib.h>
#include <stdio.h> /* For stderr */
#include "porrog_defs.h"

static long alloc_count=0;
/* Will change this to an array of counts for different types,
   and change counting_malloc and counting_free to also take an
   identifier of what type they're dealing with.
   Some time. */
static long alloc_counts[MEM_LASTTYPE];

/* Just for safety! */
void memutils_init()
{
    strgrp_t i;
    for(i=MEM_LVLMAP;i<MEM_LASTTYPE;i++) alloc_counts[i]=0;
}

/* changed from (size_t size)  to  (strgrp_t grp, size_t size) */
void *counting_malloc(strgrp_t grp, size_t size)
{
    alloc_counts[grp]++;
    alloc_count++;
    return malloc(size);
}

/* changed from (void *ptr)  to  (strgrp_t grp, void *ptr) */
void counting_free(strgrp_t grp, void *ptr)
{
    alloc_counts[grp]--;
    alloc_count--;
    free(ptr);
}

long check_allocs()
{
    strgrp_t i;
    fprintf(stderr,"Checking for unfreed memory groups...\n");
    for(i=MEM_LVLMAP;i<MEM_LASTTYPE;i++) {
       if (alloc_counts[i]==0) continue; /* Don't show the OK ones */
       fprintf(stderr,"GRP %d: %ld unfreed%s",i,alloc_counts[i],i==19?" (this group known to be bad, don't worry).\n":".\n");
    }
    fprintf(stderr,"...done.\n");
    return(alloc_count);
}
