/* ==== save.c ==== */
/* PRO-TEM source for saving and reloading game state. Should probably
   be replaced. UNSURE if the format produced will be platform-independent.*/
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */







#include "porrog_defs.h"
#include "item_t.h"
#include "structures.h"


/* ARRANGEMENT: have functions to dump and reload a structure, such as:
   -itemtypes, items, level structures, monsters, player.

   The obvious way to deal with things with lists is to dump each item
   in sequence with some sort of terminator item at the end. HOWEVER
   this gets spoilt by the realisation that for instance, items have *2*
   "next" elements! One is for heap lists, and the other is for level-wide
   item lists. But all is not lost! On closer inspection, the level-wide
   item list element ("Next2") only applies to items on the floor of the
   dungeon, and should be null within inventories. And when items are on
   the floor, in a heap, the order of the heap should be the same as that
   of the level-list! The "replace_items()" function depends on this to
   place all the items in the same order as they'd been left. When it runs,
   it fills in the "Next" element for those items, so it doesn't even need
   to be filled in in the savefiles!
   I forget whether the structures for level data have similar intermeshing
   issues, it's quite possible :(

   As the game should (??) have a constant number of itemtypes, it should
   be possible to pack the itemtype references into 16 bits or so (~4 bits
   for itemgroup, and 12 bits should be WAY more than enough to express the
   index into the list). We could have a cache here of index-to-pointer data.
   Hmm, perhaps having THAT many would be awkward, but we could have a cache
   of itemtypes of index==index%8, and each itemtype could reasonably store
   its index number. Hence looking up an itemtype by number should be quick
   and the opposite should be instant.
   Only data for itemtypes that needs to be in the savefile is the flavour
   data, and "known" status. And probably similar stuff :P

   Monsters could be saved in a big list per level just like the items. They
   would have their various stats stored in a similar form to those of the
   player, so these blocks of stats could have functions to dump them too.

   Terminators for items and terminators for monsters could simply have the
   type field set to NULL... except that in the save files, these fields
   would be expressed as an index rather than a pointer- so they should be
   expressed as something like FFFF etc instead. We're NOT going to have
   65536 items or monsters. Really.
   */

   /* now the lack of code ;) */


/* ==== end of save.c ==== */
