/* ==== syscurses.c ==== */
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */



#include "syscurses.h"
#include "enums.h"

/* stuff for initialising curses, that doesn't want to be in ui.c
   because porroghelp wants to use it too, but doesn't want the rest
   of ui.c.
   Mostly responsible for assigning colour pairs in such a way that
   functions that set colour enumerations do NOT need to include
   curses.h (indirectly or otherwise) before getting access to them */


void init_colours() {
   typedef struct {
      pcolour_t pcolour;
      short cursescolour;
   } cmapping_t; /* just used for this function, NOTHING else! */
   cmapping_t mapping[/* 7 */]={
      /* don't define a mapping for white... because it's predefined!! */
      {PCOL_DRED,COLOR_RED},
      {PCOL_DBLUE,COLOR_BLUE},
      {PCOL_MAGENTA,COLOR_MAGENTA},
      {PCOL_DGREEN,COLOR_GREEN},
      {PCOL_BROWN,COLOR_YELLOW},
      {PCOL_DCYAN,COLOR_CYAN},
      {PCOL_INV,COLOR_BLACK}
   };
   int i;
   start_color();
   if(has_colors()&&COLOR_PAIRS>7) {
      /* Set up colours and colour pairs */
      for (i=0;i<7;i++)
         init_pair(mapping[i].pcolour,mapping[i].cursescolour,COLOR_BLACK);
         /* COLOR_BLACK==0 IIRC so I used to use 0 there but that's naughty*/
   }
   /* I think that's it now!! Unless we decide to put all
      the cbreak() type stuff here, but I dunno */
}



                        
/* Make these inline functions instead.  */
/* void setpcolour(pcolour_t colour) { -* wrapper for color_set and attrset *-
   if(colour==PCOL_INV) {
      attrset(A_REVERSE),color_set(0,NULL)
   } else {
     (colour>=PCOL_BWHITE) ?
       attrset(A_BOLD),color_set(colour-8,NULL) :
       attrset(A_NORMAL),color_set(colour,NULL);
   }
} */

/* void wsetpcolour(WINDOW *win,pcolour_t colour) {-* setpcolour for window *-
   if(colour==PCOL_INV) {
     wattrset(win,A_REVERSE),wcolor_set(win,0,NULL)
   } else {
     (colour>=PCOL_BWHITE) ?
       wattrset(win,A_BOLD),wcolor_set(win,colour-8,NULL) :
       wattrset(win,A_NORMAL),wcolr_set(win,colour,NULL);
   }
} */

/* ==== end of syscurses.c ==== */
