/* ==== syscurses.h ==== */
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */



/* stopgap for until Autoconf is eventually used.
   Just because *nix uses ncurses whilst Windows needs pdcurses.
   How bloody lame */

/* MUST include EITHER enums.h, or porrog_defs.h (which itself includes
   enums.h) before this file. Majority of source files will include the
   latter by default. */

#ifdef WIN32
 #include <curses.h>
 #define color_set(pairno,ign) attron(COLOR_PAIR(pairno))
 #define wcolor_set(win,pairno,ign) wattron(win,COLOR_PAIR(pairno))
#else
 #include <ncurses.h>
#endif

/* NOW the enumeration that I wanted to put in enums.h :P */

void init_colours();
/* HA! Now the connection between Porrog's colour values
   and curses's colour values has been moved into the initialisation
   function, the actual colour enumerations can go *back* into enums.h!

typedef enum {
   PCOL_DWHITE=0,
   PCOL_DRED=COLOR_RED+1,
   PCOL_DBLUE=COLOR_BLUE+1,
   PCOL_MAGENTA=COLOR_MAGENTA+1,
   PCOL_DGREEN=COLOR_GREEN+1,
   PCOL_BROWN=COLOR_YELLOW+1, -* ==dim yellow *-
   PCOL_DCYAN=COLOR_CYAN+1,
   PCOL_INV=COLOR_BLACK+1, -* ODD COLOUR OUT! Is *reverse* attribute! *-

   PCOL_BWHITE=8, -* 8+0 *-
   PCOL_BRED=COLOR_RED+9,
   PCOL_BBLUE=COLOR_BLUE+9,
   PCOL_PINK=COLOR_MAGENTA+9,
   PCOL_BGREEN=COLOR_GREEN+9,
   PCOL_YELLOW=COLOR_YELLOW+9, -* ==bright yellow *-
   PCOL_BCYAN=COLOR_CYAN+9,
   PCOL_GREY=COLOR_BLACK+9 -* dark grey, == bright black, just called grey *-
} pcolour_t; */
                        

/* These REALLY want to be inline functions rather than macros. */
/* void setpcolour(pcolour_t colour); -* wrapper for color_set and attrset */
#define setpcolour(colour) if(colour==PCOL_INV) \
  attrset(A_REVERSE),color_set(0,NULL); else \
  (colour>=PCOL_BWHITE) ? \
     (attrset(A_BOLD),color_set(colour-8,NULL)) : \
     (attrset(A_NORMAL),color_set(colour,NULL))

/* void wsetpcolour(WINDOW *win,pcolour_t colour); -* setpcolour for window */
#define wsetpcolour(win,colour) if(colour==PCOL_INV) \
  wattrset(win,A_REVERSE),wcolor_set(win,0,NULL); else \
  (colour>=PCOL_BWHITE) ? \
     (wattrset(win,A_BOLD),wcolor_set(win,colour-8,NULL)) : \
     (wattrset(win,A_NORMAL),wcolor_set(win,colour,NULL))

/* these would be better done as functions ATM in ui.c? */

/* ==== end of syscurses.h ==== */
