/* ==== testcard.c ==== */
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */


#include "enums.h"
#include "syscurses.h"
#include <unistd.h>
#include <stddef.h>



/* TEH TEST CARD PROGRAM */
int main(int argc, char **argv)
{
    typedef struct {
       char *Name;
       /*
       int Col; -* follows same semantics as rest of porrog:
                 0-7 are dull (0=white,7==?) 8+ are bright. */
       pcolour_t Col;
    } colstruct_t;
    colstruct_t colourdata[]={
      {"plain white/pale grey",PCOL_DWHITE}, /* 0 */
      {"red",PCOL_DRED}, /* COLO:R_RED+1 */
      {"blue",PCOL_DBLUE}, /* COLO:R_BLUE+1 */
      {"magenta",PCOL_MAGENTA}, /* COLO:R_MAGENTA+1 */
      {"green",PCOL_DGREEN}, /* COLO:R_GREEN+1 */
      {"pale brown/dull yellow",PCOL_BROWN}, /* COLO:R_YELLOW+1 */
      {"turquoise/dull cyan",PCOL_DCYAN}, /* COLO:R_CYAN+1==7 */
      {"inverse!",PCOL_INV}, /*?!  COLO:R_BLACK+1*/

      {"bright white",PCOL_BWHITE}, /* 8 */
      {"bright red/orange",PCOL_BRED}, /* COLO:R_RED+9 */
      {"bright blue",PCOL_BBLUE}, /* COLO:R_BLUE+9 */
      {"bright pink",PCOL_PINK}, /* COLO:R_MAGENTA+9 */
      {"bright green",PCOL_BGREEN}, /* COLO:R_GREEN+9 */
      {"bright yellow",PCOL_YELLOW}, /* COLO:R_YELLOW+9 */
      {"bright cyan",PCOL_BCYAN}, /* COLO:R_CYAN+9 */
      {"dark grey",PCOL_GREY} /* COLO:R_BLACK+9 */
    };
    int i,col,y;

    /* Set up curses stuff */
    if (initscr()==NULL)
    { /* crash(SCREEN_ERROR); crash() now goes through curses! */
      fprintf(stderr,"Yarg! Porrog couldn't initialise the terminal display! Quitting.\n");
      exit(1);
    }
    /* LINES should now store the number of lines in the
    current terminal. In wterm and the Linux console (AFAIK) this should
    be 25, but in xterm this is 24! */
    /*
    start_color(); --
    if(has_colors()&&COLO:R_PAIRS>7) { --
       -* Set up colours and colour pairs *-
       for(i=0;i<7;i++) { -* *7* is OK for this value, because 0->6 gives
                          colour pair numbers of 1->7, and pair 0 is already
                          allocated. Hence we have 8 colour pairs. Testing
                          this by reducing the 7 to 6 makes the cyan get
                          unassigned, making it look as though the black
                          was previously unassigned... but that's actually
                          just due to the pairs being accessed out of order.
                          Cyan is colour 7 in NCurses. *-

                          Now all this is handled by syscurses.[ch] ...but
                          event that still only needs to allocate 7 pairs ;)
         init_pair(i+1,i,0); --
       }
    } */
    init_colours(); /* in syscurses.c */
    notimeout(stdscr, 1);
    noecho();
    cbreak();


/* DRAW TEST CARD! */
    for(i=0;i<16;i++) {
       clear();
       /*
       attrset(A_NORMAL);
       color_set(0,NULL); */
       setpcolour(PCOL_DWHITE);
       move(5,15);addstr("About to draw a ");
       addstr(colourdata[i].Name); addstr(" square...");
       refresh();
       sleep(1);
       col= colourdata[i].Col;
       setpcolour(col);
       /*
       if(col>7) {
          attrset(A_BOLD); -* A_DIM seems to be the norm? *-
          color_set(col-8,NULL);
       } else {
          color_set(col,NULL);
       } */
       for(y=8;y<15;y++) {
          move(y,25);addstr("##########");
       }
       /*
       attrset(A_NORMAL);color_set(0,NULL); */
       setpcolour(PCOL_DWHITE);
       if(i==15) {
          move(17,15);addstr("Test card completed! Thanks for your help :)");
       }
       move(18,15);addstr("Press a key!");
       refresh();
       y=getch();
    }


    endwin();
    printf("Exiting.\n");/* Should say reason for exiting */
    exit(0);
}
/* END OF TEST CARD */
