/* ==== ui.c ==== */
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */


/*#include <stdlib.h>
*/

#include <string.h> /* Was included from ui.h, but strcpy etc
   are mostly just used here. */
#include "syscurses.h"  /* because including system version of curses.h
                           directly here isn't that portable! */
#include "porrog_defs.h"
#include "C-foogrid.h"
#include "memutils.h"
#include "item_t.h"
#include "structures.h"
#include "mapgen_types.h"
#include "maparray.h" /*We need this, but maybe just for the #defines*/
#include "player_t.h"

/* protos */
#include "item_p.h"
#include "crash.h"
#include "dXrng.h"
#include "los.h"
#include "player_p.h"
#include "apply.h"
#include "ui.h"


/* char strbuf[160]; Now in globals.c */
#define discardwin(win) werase(win);wrefresh(win);delwin(win);touchwin(stdscr);refresh()


void draw_status()
{
   char linebuf[29];
   int len;
   /* char *satDesc[]={"STARVING!","fainting!","weak!","very hungry","hungry","","satiated","bloated!","BURSTING!"}; */

   /*
   color_set(COLOR_CYAN+1,NULL); */
   setpcolour(PCOL_DCYAN);
   for(len=0;len<23;len+=2) {
      move(len,29);addch('\\');
      move(len+1,29);addch('/');
   }
   /* attrset(A_NORMAL);
   color_set(0,NULL); blech!!! */
   setpcolour(PCOL_DWHITE);
/*   sprintf(linebuf,"X,Y:%d,%d",player.X,player.Y);
   -The player coords belong in a debug screen, if they're even useful-
   len=strlen(linebuf);
   strncat(linebuf+len," ||::--::||  --::||::--  ||::",29-len);
   move(0,0);
   addstr(linebuf); */

   sprintf(linebuf,"HP:%d/%d",player.Var_stats.Hp,player.Var_stats.MaxHp);
   len=strlen(linebuf);
/* strncat(linebuf+len,"                             ",29-len); */
   strncat(linebuf+len,commonstring[CSTR_29BLNK],29-len); /*save space*/
   move(9,0); /* was line 3 */
   addstr(linebuf);

/* sprintf(linebuf,"Exp:%lld",player.Var_stats.Exp);
   */
   sprintf(linebuf,"Exp:%s",u64toa(player.Var_stats.Exp));
   len=strlen(linebuf);
/*   strncat(linebuf+len,"                             ",29-len); */
   strncat(linebuf+len,commonstring[CSTR_29BLNK],29-len);
   move(8,0); /* was line 4 */
   addstr(linebuf);
   sprintf(linebuf,"Exp level:%d",player.Var_stats.Level);
   /* was just "level", but location will be added soon?? */
   len=strlen(linebuf);
   strncat(linebuf+len,commonstring[CSTR_29BLNK],29-len);
   move(7,0); /* was line 5 */
   addstr(linebuf);

   /* Jul 11 2004: satiation */
   /* sprintf(linebuf," %s",satDesc[categorizeSatiation(player.Var_stats.Satiation)]); */
   sprintf(linebuf," %s",descSatiation(categorizeSatiation(player.Var_stats.Satiation),1));
   len=strlen(linebuf);
   strncat(linebuf+len,commonstring[CSTR_29BLNK],29-len);
   move(10,0);addstr(linebuf); /* was (briefly!) 7 */
   /* Jul 12 2004: location */
   move(11,0);addstr("In teh dungeons"); /*... ;) */

   /* Base stats-These should actually be interleaved. */
   sprintf(linebuf,"STR: %d",player.Fixed_stats.Str);
   len=strlen(linebuf);
/* strncat(linebuf+len,"                             ",29-len); */
/* strcat(linebuf+len,"     "); */
   strncat(linebuf+len,commonstring[CSTR_29BLNK],5); /* check this is ok... */
   move(0,0); /* was 8,0 */
   addstr(linebuf);
   sprintf(linebuf,"DEX: %d",player.Fixed_stats.Dex);
   len=strlen(linebuf);
/* strncat(linebuf+len,"                             ",29-len); */
/* strcat(linebuf+len,"     "); */
   strncat(linebuf+len,commonstring[CSTR_29BLNK],5);
   move(0,12); /* was 9,0. Then 8,12!*/
   addstr(linebuf);
   sprintf(linebuf,"AGI: %d",player.Fixed_stats.Agi);
   len=strlen(linebuf);
/* strncat(linebuf+len,"                             ",29-len); */
/* strcat(linebuf+len,"     "); */
   strncat(linebuf+len,commonstring[CSTR_29BLNK],5);
   move(1,0); /* was 10,0. Then 9,0! */
   addstr(linebuf);
   sprintf(linebuf,"CON: %d",player.Fixed_stats.Con);
   len=strlen(linebuf);
/* strncat(linebuf+len,"                             ",29-len); */
/* strcat(linebuf+len,"     "); */
   strncat(linebuf+len,commonstring[CSTR_29BLNK],5);
   move(1,12); /* was 11,0. Then 9,12! */
   addstr(linebuf);

   /* Derived stats */
   sprintf(linebuf,"Coverage: %d%%",player.Var_stats.Cov);/*precalced already*/
   len=strlen(linebuf);
   strncat(linebuf+len,commonstring[CSTR_29BLNK],29-len);
   move(4,0);
   addstr(linebuf); /* PREFERABLY have EV in same string and then print
                       both at once. But I have no info on whether *sprintf*
                       terminates its strings with a NULL *scowl* */
#if 0 /* Just temporary! */
   sprintf(linebuf,"Ev: %d",player.Var_stats.Ev);
#else
   /* Should actually be stored in .Ev, but isn't yet */
   sprintf(linebuf,"Ev: %d",global_scale_evasion(player.Fixed_stats.Agi,player.Var_stats.Level));
#endif
   /*len=strlen(linebuf);
   strncat(linebuf+len,"                             ",29-len); */
   move(4,15); /*  was 13,0. SHOULD have in same string as covrg. */
   addstr(linebuf);
   /*
   sprintf(linebuf,"Coverage: %d%%",player.Var_stats.Cov);
   len=strlen(linebuf);
   strncat(linebuf+len,"                             ",29-len);
   move(4,0); -* was 14,0 *-
   addstr(linebuf); */
   sprintf(linebuf,"Prot Avg: %d",(player.Var_stats.Pravg/100));
   len=strlen(linebuf);
/* strncat(linebuf+len,"                             ",29-len); */
   strncat(linebuf+len,commonstring[CSTR_29BLNK],29-len);
   move(5,0); /* was 15,0 */
   addstr(linebuf);

   /* prompt area */
   if(stalePrompt) clearPrompt();
}

void draw_map(int cornerx,int cornery,int px,int py)
{
   /* We assume that curses is already initialised. */
   int x,y,sx,sy,tile;
   pcolour_t col;
   maploc_t *elem;
   maploc_t *mapstart=map->Data;
   char sym;
#ifndef AUTOPILOT
   calc_los(map,px,py);
#else
   calc_los(map,tls->Moblist->X,tls->Moblist->Y);
#endif
   /* used to be ... ,sy=1; sy<23; ... */
   for (y=cornery,sy=0;sy<24;y++,sy++)
      for (x=cornerx,elem=mapstart+FOOGRID_IDX(map,y,x),sx=30;sx<80;elem++,sx++,x++)
      {
          move(sy,sx);
          /* PRE syscurses.c code
          attrset(A_NORMAL);
          color_set(0,NULL); */
          setpcolour(PCOL_DWHITE); /* Ideally, we'd remember whether or
                                     not we'd changed from PCOL_DWHITE to
                                     anything else before setting it here */
#ifndef AUTOPILOT
          if (in_los(px,py,x,y))
#else
          if (in_los(tls->Moblist->X,tls->Moblist->Y,x,y))
#endif
          {
           elem->Seen=1;
           elem->Remembered=NULL; /* Update it whenever square seen */
           if(NULL!=elem->Mptr) {
             sym=elem->Mptr->Mobtype->Symbol;
             col=elem->Mptr->Mobtype->Colour;
             setpcolour(col);
           }
           else if (px==x&&py==y) sym=player.Symbol;
           else if (NULL!=elem->Itemlist)
           {
              sym=elem->Itemlist->Itemtype->Symbol;
              elem->Remembered=elem->Itemlist->Itemtype;
              col=elem->Itemlist->Itemtype->Col;
              /* PRE syscurses.c code:
              if(col>7) { -* do bright *-
                 attrset(A_BOLD);
                 color_set(col-8,NULL);
              } else color_set(col,NULL); -* Now just: */
              setpcolour(col);
           } else{
             tile=elem->Tiletype; /* show the floor */
             switch(tile)
             {
                 case PTL_PWALL:
                 case PTL_CORNER:
                   /* attrset(A_NORMAL);
                   color_set(0,NULL); */
                   col=PCOL_DWHITE;
                   sym='#';break;
                   sym='*';break;
                 case PTL_ROCK:
                /* attrset(A_BOLD);
                   color_set(COLO:R_BLACK+1,NULL); */
                   /* attrset(A_NORMAL);
                   color_set(COLO:R_GREEN+1,NULL); */
                   col=PCOL_DGREEN; /* do we even *want* tunnel walls seen?*/
                   sym='#';break;
                 case PTL_HWALL:
                   /* attrset(A_NORMAL);
                   color_set(0,NULL); */
                   col=PCOL_DWHITE;
                   sym='#';break;
                   sym='-';break;
                 case PTL_VWALL:
                   /* attrset(A_NORMAL);
                   color_set(0,NULL); */
                   col=PCOL_DWHITE;
                   sym='#';break;
                   sym='|';break;
                 case PTL_DOOR:
#ifndef NEW_DOOR /* NEW_DOOR represents closed doors by a dummy item */
                   /* attrset(A_NORMAL);
                   color_set(COLO:R_YELLOW+1,NULL); */
                   col=PCOL_BROWN;
                   sym='+';break;
#endif
                 case PTL_ODOOR:
                   /* attrset(A_NORMAL);
                   color_set(COLO:R_YELLOW+1,NULL); */
                   col=PCOL_BROWN;
                   sym=':';break; /* Er, I suppose*/
                 case PTL_TUNNEL:
                   /* attrset(A_BOLD);
                   color_set(COLO:R_BLUE+1,NULL); */
                   col=PCOL_BBLUE;
                   sym=':';break;
                 case PTL_STAIRSUP:
                   /* attrset(A_BOLD);
                   color_set(COLO:R_YELLOW+1,NULL); */
                   col=PCOL_YELLOW;
                   sym='<';break;
                 case PTL_STAIRSDOWN:
                   /* attrset(A_NORMAL);
                   color_set(COLO:R_YELLOW+1,NULL); */
                   col=PCOL_BROWN;
                   sym='>';break;
                 case PTL_ALTAR: /* And maybe some others? */
                   /* attrset(A_BOLD);
                   color_set(COLO:R_CYAN+1,NULL); */
                   col=PCOL_BCYAN;
                   sym='_';break;
                 case PTL_FLOOR:
                 case PTL_RMID:
                   /* attrset(A_NORMAL);
                   color_set(0,NULL); */
                   col=PCOL_DWHITE;
                   sym='.';break;
                 default:
                   sym=''; /* Foobar!!!*/
                   col=PCOL_INV;
             }
             setpcolour(col); /* should probably be done further on!! */
           }
          } else
          { /* draw from memory */
            if(elem->Seen)
            {
               if(NULL!=elem->Remembered) sym=elem->Remembered->Symbol;
               else switch (elem->Tiletype) {
                       case PTL_PWALL:
                       case PTL_CORNER:
                          sym='#';break;
                          sym='*';break;
                       case PTL_ROCK:
                          sym='#';break;
                       case PTL_HWALL:
                          sym='#';break;
                          sym='-';break;
                       case PTL_VWALL:
                          sym='#';break;
                          sym='|';break;
                       case PTL_DOOR:
                          sym='+';break;
                       case PTL_ODOOR:
                          sym=':';break;
                       case PTL_TUNNEL:
                          sym=':';break;
                       case PTL_STAIRSUP:
                          sym='<';break;
                       case PTL_STAIRSDOWN:
                          sym='>';break;
                       case PTL_ALTAR:
                          sym='_';break;
                       case PTL_FLOOR:
                       case PTL_RMID:
                          sym='.';break;
                       default:
                          sym='';
               }
            } else sym=' '; /* blank! */
          }
          addch(sym);
      }
   refresh();
}

void show_messages(char *msg)
{
#define MESSAGESPACE_TOP 18
   /* Message area starts from line MESSAGESPACE_TOP, and runs from column 0
     to column 29. I think. Or is it 28? 
     Top was originally set to 18, may be changed to give more space. */
   char linebuf[29];
   char *startptr=msg;
   char *safeptr; /* When we find a bad line, this will be the end.*/
   char *testptr;
   int msglen; /*=strlen(msg); */
   int line;
   int done=0;
   static int startline=MESSAGESPACE_TOP,startcol=0,refr=0;
   if (msg==NULL) {
     startline=MESSAGESPACE_TOP;startcol=0;refr=1;return;/* Reset the thing */
   }
   /* Put this message in the ringbuffer */
   if (messages_ringbuffer[mrb_endidx]!=NULL) counting_free(MEM_STRING,messages_ringbuffer[mrb_endidx]);
   messages_ringbuffer[mrb_endidx]=counting_malloc(MEM_STRING,sizeof(char)*(1+strlen(msg)));
   strcpy(messages_ringbuffer[mrb_endidx],msg);
   mrb_endidx++; if(mrb_endidx==200) mrb_endidx=0;
   if (mrb_endidx==mrb_startidx) { /* Wrapped */
      mrb_startidx++; if (mrb_startidx==200) mrb_startidx=0;
   }
   do {
      for (line=startline;line<22;line++,startcol=0)
      {
         msglen=strlen(startptr);
         safeptr=startptr+msglen-1; /* why did I do this? I forget.*/
         testptr=strchr(startptr,' ');
         if ((testptr==NULL)&&msglen>27) crash(IO_ERROR);/*see below*/
         if ((testptr-startptr)>27) crash(IO_ERROR); /*Cant do owt wi that*/
         if ((testptr==NULL)&&msglen>(27-startcol)) continue;
         if ((testptr-startptr)>(27-startcol)) continue;/*Start on next line*/
         for(;
           testptr!=NULL&&(testptr-startptr)<(28-startcol);
           safeptr=testptr+1,testptr=strchr(safeptr,' '))
         ;

    /*if (testptr==NULL) msglen=strlen(startptr);  */
         if (startcol+msglen>29) msglen=(safeptr-startptr)-1;
         else done=1;
/* This needs much working out. Except it does seem to work now */
         if(startcol+msglen>29) crash(FUNCTION_ERROR); /*Arrgh!*/
         move(line,startcol);
         strncpy(linebuf,startptr,msglen);
         *(linebuf+msglen)='\0'; /*Add a null.*/
         strncat(linebuf,"                               ",29-(msglen+startcol));
         addstr(linebuf);
         refresh(); /* Should be done at the END of the routine.*/
         /* Was (testptr==NULL) */
         if(done) {startcol+=msglen+2;break;}
         startptr=safeptr;
      }
      startline=line;
      if(refr) {/* Clear the rest */
        for (line=startline+1;line<22;line++)
        {
           move(line,0);
           addstr("                             ");
        }
        refr=0;
      }
      if (startline>=22&&(!done)) { /* Hit the end. */
         move(23,1); /* in certain terminals you can use 24, but not all */
         addstr("[SPACE for more]");
         while(getch()!=' ');
         move(23,1);
         addstr("                ");
         startline=MESSAGESPACE_TOP;startcol=0;refr=1;
      }
   } while(/* testptr!=NULL*/ !done) ;
}

void issuePrompt(char *title,char *prompt) {
   char linebuf[30];
   int i,tlen,line,messagelen;
   char *pstart;

   move(17,0);
   for(i=0;i<29;i++) linebuf[i]='=';
   linebuf[29]='\0';
   addstr(linebuf);
   move(14,0);
   tlen=strlen(title);
   strncpy((linebuf+14)-(tlen/2),title,tlen);
   addstr(linebuf);

   for(line=15,pstart=prompt;line<17&&*pstart!=0;line++,pstart+=messagelen+1){
     messagelen=lastSpace(pstart,29);
     move(line,0);strncpy(linebuf,pstart,messagelen);
     strncpy(linebuf+messagelen,"                              ",29-messagelen);
     /* *(linebuf+29)='\0'; */

     addstr(linebuf);
   }
   if(line==16) { /* clear bottom line if not already done */
     for(i=0;i<29;i++) linebuf[i]=' ';
     move(16,0);addstr(linebuf);
   }
   refresh();
   /* k=getch(); -only relevant if we decide we want a scrollable prompt */
}

void clearPrompt() {
   int i;
   char linebuf[30];

   /* borders */
   for(i=0;i<29;i++) linebuf[i]='=';
   linebuf[29]='\0';
   for(i=14;i<18;i+=3) {
      move(i,0);addstr(linebuf);
   }
   /* prompt space */
   for(i=0;i<29;i++) linebuf[i]=' ';
   for(i=15;i<17;i++) {
      move(i,0);addstr(linebuf);
   }
   stalePrompt=0;
   refresh();
}

/* Read the messages ringbuffer (usu with ^P) */
void show_mrb()
{
   /* Not sure how to do the scrolling... */
   WINDOW *win;
   int i,rbi,tot,bline,line;
   int k;
   win=newwin(22,76,1,2);

   for(rbi=mrb_startidx,tot=0; /* */ ;rbi++,tot++) {
      if (rbi==200) rbi=0;
      if(rbi==mrb_endidx) break;
   }
   /* Now have  tot == number of lines in ringbuffer */
   bline=(tot-19);if(bline<0) bline=0;
   line=bline;
   /* draw frame */
   for(i=1;i<21;i++) {
     wmove(win,i,0);waddch(win,'|');
     wmove(win,i,75);waddch(win,'|');
   }
   for(i=1;i<75;i++) {
     wmove(win,0,i);waddch(win,'-');
     wmove(win,21,i);waddch(win,'-');
   }
   wmove(win,0,30);waddstr(win,"Message history:");
   wmove(win,0,0);waddch(win,'+');wmove(win,0,75);waddch(win,'+');
   wmove(win,21,0);waddch(win,'+');wmove(win,21,75);waddch(win,'+');
   /* main display loop */
   do {
      /* werase(win); Or blank each line? */
      for(i=1,rbi=mrb_startidx+line;i<20&&rbi!=mrb_endidx;i++,rbi++) {
         if (rbi>=200) rbi-=200;
         wmove(win,i,1);
         if (messages_ringbuffer[rbi]==NULL) break; /* End of thingy */
         if(strlen(messages_ringbuffer[rbi])>73) sprintf(messages_ringbuffer[rbi]+70,"...");
         waddstr(win,messages_ringbuffer[rbi]);wclrtoeol(win);
         wmove(win,i,75);waddch(win,'|');
      }
      wmove(win,20,21);
      waddstr(win,"k:up j:down <SPACE>:return to game");
      touchwin(win);wrefresh(win);
      k=getch();
      if('k'==k && line>0) line--;
      if('j'==k && line<bline) line++;
   }
   while(' '!=k); /* Space to exit */
   /* Now remove the window */
   werase(win);wrefresh(win); delwin(win); /* clear+remove this window */

   touchwin(stdscr); refresh(); /* Refresh main window */
}

void free_mrb()
{
   int rbi;
   for(rbi=mrb_startidx;rbi!=mrb_endidx; rbi++) {
      if(rbi==200) rbi=0; /* DOES THIS NEED FIXING TOO? See show_mrb() changes*/
      if (messages_ringbuffer[rbi]==NULL) {
         fprintf(stderr,"free_mrb() found a NULL pointer.\n");
         break;
      }
      counting_free(MEM_STRING,messages_ringbuffer[rbi]);
   }
   if(messages_ringbuffer[rbi]!=NULL) counting_free(MEM_STRING,messages_ringbuffer[rbi]);
   /* Check this is good */
}

void msg_window(char *msg)
{
   int x,y;
   int length=strlen(msg);
   int xe=43+(length/2);
   for(x=37-(length/2);x<xe;x++)
   {
      move(8,x);addch('-');
      move(12,x);addch('-');
   }
   for(y=9;y<12;y++)
   {
      move(y,37-(length/2));addch('|');
      move(y,xe);addch('|');
   }
   move(8,37-(length/2));addch('+');
   move(12,37-(length/2));addch('+');
   move(8,xe);addch('+');
   move(12,xe);addch('+');
   move(10,40-(length/2));addstr(msg);
   move(14,0);
   refresh();
}

/* initially useful for choosing doors, but will have further
   uses in future */
direction_t userSelectDir(char *question, int allow_here, int allow_updown) {
   /* allocate a buffer dynamically instead? */
   char prompt_string[64];
   int keypress;
   sprintf(prompt_string,"%s [hykulnjb%s]?",question,allow_here?(allow_updown?".<>":"."):(allow_updown?"<>":""));
   /* show_messages(prompt_string); */
   issuePrompt("Direction(fix!)",prompt_string);
   stalePrompt=1;
   while(1) {
      keypress=getch();
      switch(keypress) {
         case 27: return FACE_NONE; /* ESC */
         case 'h': return FACE_W;
         case 'j': return FACE_S;
         case 'k': return FACE_N;
         case 'l': return FACE_E;

         case 'y': return FACE_NW;
         case 'u': return FACE_NE;
         case 'b': return FACE_SW;
         case 'n': return FACE_SE;
         /* ditto for CAPITALISED dirs???? */
         case '.':
             if(allow_here) return FACE_HERE; /* also self */
             else break;
         case '<':
             if(allow_updown) return FACE_UP;
             else break;
         case '>':
             if(allow_updown) return FACE_DOWN;
             else break;
         default: ;
      }
      /* carry on till dir chosen */
   }
}

item_t *prompt_for_inv_item(int flag)
{ /* Tricky one. Takes list, displays it, asks you to pick one.*/
  /* Problem: Lists of items in your inventory are handled
     differently to items on the floor or in containers.
     Solution: give 2 functions:
         prompt_for_inv_item()
     and prompt_for_heap_item(item_t *list). */
/* int line;   Don't we use this?? */
   char k;
   item_t *item;
   if (NULL==player.Inventlist) {
     show_messages("You're not carrying anything!");
     return(NULL);
   }
   /* was using show_messages */
   issuePrompt(flag?"Wield item":"Choose item",flag?"Wield what? ? to choose item from list, - to wield nothing, ESC to cancel (FIXME)":"Which item? ? to choose from list.");
   stalePrompt=1;
   while(1){
     k=getch();
     if (k=='?') { /* Show the list first */
        /*
        for(line=1,item=player.Inventlist;item!=NULL;line++,item=item->Next)
        {
           if(line<22) {move(line,0);
             addch(item->Invletter); addch(':');
             addstr(item->Itemtype->Name);}
        }
        refresh(); */
        /* display_heap("Items available",player.Inventlist); -* Tidier now */
        item=displayHeapV2(PLISTMODE_PICKALLINV,"Items available",player.Inventlist);
        if(item!=NULL) return(item);
     } else { /* Got a choice! If valid, return it. */
        if (k=='-'&&flag) return(phonyitem);
        if ((k>='a'&&k<='z')||(k>='A'&&k<='Z')) /* if(isalpha(k))... */
        {
           /* item=getItemByInvletter(k); if (item!=NULL) return(item); */
           /* uh, more like:
             if(!invletterIsAvailable(k)) return (getItemByInvletter(k)); */
           for (item=player.Inventlist;item!=NULL;item=item->Next)
              if(item->Invletter==k) return(item);
           show_messages("You don't have *that*!");
        }
        if (k==27) /* ESC */ return(NULL);
     }
   }
}

item_t *prompt_for_heap_item(item_t *list)
{
   int line,items,choice,i;
   char nstring[80];/* print item descriptions */
   char k=' ';
   item_t *item;
   WINDOW *win;
   show_messages("Choose an item");
   refresh();
   return(displayHeapV2(PLISTMODE_PICKALLHEAP,"Pick from list(to be recoded)",list));
   while(list!=NULL) /* Er... */
   {
     for(items=0,item=list; items<15&&item!=NULL; items++,item=item->Next);
     win=newwin(items+4,60,9-(items/2),10);
     for(line=0,item=list; line<items &&item!=NULL; line++, item=item->Next)
     {
        wmove(win,line+2,0);waddch(win,'|');
        waddch(win,line+'a'); waddch(win,':');
        waddch(win,item->Itemtype->Symbol);waddch(win,' ');
        describe_item(nstring,item); /* used to use item->Itemtype->Name */
        waddstr(win,nstring);/*waddstr(win,"      ");  Should be better.*/
        /* Newly copied from display_heap() */
        wmove(win,line+2,59);waddch(win,'|');
     }
     wmove(win,0,0);waddch(win,'+');
     wmove(win,0,59);waddch(win,'+');
     wmove(win,line+3,0);waddch(win,'+');
     wmove(win,line+3,59);waddch(win,'+');
     wmove(win,1,0);waddch(win,'|');
     wmove(win,1,59);waddch(win,'|');
     wmove(win,line+2,0);waddch(win,'|');
     wmove(win,line+2,59);waddch(win,'|');
     wmove(win,0,1);for(i=0;i<58;i++)waddch(win,'-');
     wmove(win,line+3,1);for(i=0;i<58;i++)waddch(win,'-');
/*   for(;line<15;line++)  Blank the rest 
     { move(line+1,3);addstr("                        ");  That'll do. 
     } */
     touchwin(win);wrefresh(win); /* Display the window...*/
     while(1)
     {
       k=getch();
       if ('a'<=k && ('a'+items)>k) /* Was source of foobar... */
       {  /* Got one. Which was it? */
          choice=(k-'a');
          for(line=0,item=list; line<choice&&item!=NULL;line++,item=item->Next);
          if(NULL==item) crash(FUNCTION_ERROR); /* Shouldn't happen */
          discardwin(win);
          return(item);
       }
       if(27==k) {discardwin(win);return (NULL);} /* Don't choose anything */
       if(' '==k) break; /* Next page. */
     }
     /* User must have pressed <space> to choose next page. */
     list=item;
     discardwin(win);
   }
   /* GCC complains about control reaching here. Should it be
      returning NULL here? Or not reaching this point?? I'll look
      at it later. I suspect we should return NULL anyway. */
   return (NULL);
}

void display_heap(char *title,item_t *list)
{
   int count=0,x=0;
   item_t *scan;
   char nstring[80];
   WINDOW *win;
   for(scan=list;scan!=NULL;scan=scan->Next)
      count++;
   if(count==0)return;
   /*
   move(8,1);
   addch('0'+(count/10));
   addch('0'+(count%10));
   refresh(); */
   win=newwin(count+4,60,9-(count/2),10);
   wmove(win,1,30-(strlen(title)/2));waddstr(win,title);
   for(count=0,scan=list;scan!=NULL;scan=scan->Next,count++)
   {
     wmove(win,count+2,0);waddch(win,'|');
     waddch(win,scan->Invletter);waddch(win,':');
     waddch(win,scan->Itemtype->Symbol);waddch(win,' ');
     describe_item(nstring,scan); /* used to use scan->Itemtype->Name */
     waddstr(win,nstring);
     wmove(win,count+2,59);waddch(win,'|');
   }
   wmove(win,0,0);waddch(win,'+');
   wmove(win,0,59);waddch(win,'+');
   wmove(win,count+3,0);waddch(win,'+');
   wmove(win,count+3,59);waddch(win,'+');
   wmove(win,1,0);waddch(win,'|');
   wmove(win,1,59);waddch(win,'|');
   wmove(win,count+2,0);waddch(win,'|');
   wmove(win,count+2,59);waddch(win,'|');
   for(x=1;x<59;x++)
   {  wmove(win,0,x);waddch(win,'-');
      wmove(win,count+3,x);waddch(win,'-');
   }
   wmove(win,count+2,30-(strlen("Press <space> to continue")/2));
   waddstr(win,"Press <space> to continue");
   touchwin(win);
   wrefresh(win);
   while(' '!=getch())
   {}
   werase(win);wrefresh(win); /* blank it!*/
   delwin(win);

   touchwin(stdscr); /* I have to do this to restore what was under the */
   refresh(); /* window I just removed. Is this really the *only* way?? */

}

item_t *displayHeapV2(listmode_t mode, char *title, item_t *list) {
   /* as display_heap, but hopefully not broken;
   also lists list in groups */
   int count=0,pageLength,x=0,col,k;
   item_t *scan;
   itemgroup_t sgrp,ngrp; /* groups that scan and next are in */
   item_t *next; /* temp var */
   item_t *pageHead; /* start of current page */
   item_t *pageBound; /* item (or NULL) that isn't on current page */
   char nstring[80];
   /* for *player inventory* listings, we can use getItemByInvletter()
    but for anything else, we need to remember what the heap letters
    point to for each page. Well, unless we decide to calculate it
    again each time, but that's stupid! */
   item_t *heapPointers[17]; /* pointers to items on current page by
        heap letter.is 17 enough? */
   char lastHeapItem; /* heapletter for last item on page (in heaps) */
   WINDOW *win;
   /* FLAGS: */
   int invlist=(mode==PLISTMODE_SHOWINV||mode==PLISTMODE_PICKALLINV||mode==PLISTMODE_PICKSPLINV);
   /* also show equipment iff invlist */
   int showLetters=(mode!=PLISTMODE_SHOWHEAP);
   int allowPick=(mode!=PLISTMODE_SHOWINV&&mode!=PLISTMODE_SHOWHEAP);
   int pickCount=(mode==PLISTMODE_PICKSPLINV||mode==PLISTMODE_PICKSPLHEAP);
   int eqitem; /* set for each item if appropriate */
   char thisLetter; /* eventually lastHeapItem==thisLetter */


   pageHead=nextItemByGroupThenList(list,NULL); /* gives first item to list*/
   /* if pageHead==NULL, list is empty! Suitable message for that? */
   /* now, for each PAGE of inventory, work out how many lines... */
   while(1) { /* or something */
     pageLength=0; pageBound=NULL;
     if(pageHead!=NULL) sgrp=pageHead->Itemtype->Type;
     else return(NULL); /* End of list :) */
     /* calculate page length */
     for(scan=pageHead;scan!=NULL && pageLength<17; scan=next,sgrp=ngrp) {
       pageLength++;
       next=nextItemByGroupThenList(list,scan);
       pageBound=next;
       if(next!=NULL) {
          ngrp=next->Itemtype->Type;
          if(sortInventoryGroup(sgrp,ngrp)!=0) { /* group transition */
            if(pageLength<16) pageLength+=2; /* 2 extra lines needed */
            else {
              /* pageBound=scan; -* DONT use "next" as last item! */
              break; /* but end prematurely */
            }
          }
       }
     }
     if(pageLength==0)return(NULL); /* is this called?!*/
     /* *actually*, if count goes over due to awkwardly placed
     group transition, we'd like to find *old* value of scan
     instead. Perhaps this could be fixed up. */
     /* well, perhaps later... */
     /* page length is now calculated. */
     /* Next is copied mostly verbatim from original display_heap... */
     win=newwin(pageLength+4,60,9-(pageLength/2),10);
     /*wmove(win,0,30-(strlen(title)/2));waddstr(win,title);-* overwritten!!*/
     sgrp=pageHead->Itemtype->Type;lastHeapItem='a';
     itemGroupHeading(nstring,sgrp);wattrset(win,A_UNDERLINE);
     wmove(win,1,30-(strlen(nstring)/2)); waddstr(win,nstring);
     wattrset(win,A_NORMAL);
     /* listing */
     for (count=0,scan=pageHead; scan!=pageBound;scan=next,count++) {
        wmove(win,count+2,0);waddch(win,'|'); /* pane */
        eqitem=(invlist&&p_has_equipped(scan));
        /* if equipped, '<' */
        waddch(win,eqitem?'<':' ');
        col=scan->Itemtype->Col;
        wsetpcolour(win,col);
        /* if(col>7) {wattrset(win,A_BOLD);wcolor_set(win,col-8,NULL);
        } else wcolor_set(win,col,NULL); */
        /* colour */ waddch(win,scan->Itemtype->Symbol); /* uncolour */
        wsetpcolour(win,PCOL_DWHITE);
        waddch(win,eqitem?'>':' ');
        if(showLetters) {
          thisLetter=(invlist?scan->Invletter:lastHeapItem++);
          if(!invlist) heapPointers[thisLetter-'a']=scan;
          waddch(win,thisLetter);waddch(win,':');
        } else {
          waddstr(win,"  ");
        }
        describe_item(nstring,scan); waddstr(win,nstring);
        wmove(win,count+2,59);waddch(win,'|');
        next=nextItemByGroupThenList(list,scan);
        if(next!=pageBound) {
           ngrp=next->Itemtype->Type;
           if(sortInventoryGroup(ngrp,sgrp)!=0) { /* group transition */
             /* HYPOTHESIS: as next!=pageBound, transition MUST be drawable*/
             count++; /* spacer */
             wmove(win,count+2,0);waddch(win,'|');
             wmove(win,count+2,59);waddch(win,'|');
             count++;
             wmove(win,count+2,0);waddch(win,'|');
             itemGroupHeading(nstring,ngrp);wattrset(win,A_UNDERLINE);
             wmove(win,count+2,30-(strlen(nstring)/2));waddstr(win,nstring);
             wattrset(win,A_NORMAL); wmove(win,count+2,59);waddch(win,'|');
           }
           sgrp=ngrp;
        }
     }
     wmove(win,0,0);waddch(win,'+'); wmove(win,0,59);waddch(win,'+');
     wmove(win,count+3,0);waddch(win,'+');wmove(win,count+3,59);waddch(win,'+');
     wmove(win,1,0);waddch(win,'|');wmove(win,1,59);waddch(win,'|');
     wmove(win,count+2,0);waddch(win,'|');wmove(win,count+2,59);waddch(win,'|');
     for(x=1;x<59;x++) {
       wmove(win,0,x);waddch(win,'-');
       wmove(win,count+3,x);waddch(win,'-');
     }
     /* heading! Originally was written first, but would then get overwritten*/
     wmove(win,0,30-(strlen(title)/2));waddstr(win,title);
     /* should really pick one of the various strings! */
     wmove(win,count+2,30-(strlen(commonstring[CSTR_MOREORCANCEL])/2));
     waddstr(win,commonstring[CSTR_MOREORCANCEL]);
     wmove(win,pageLength+3,0);waddch(win,'L');
     touchwin(win); wrefresh(win);
     /* now get input */
     while (1) { /* largely adapted from prompt_for_heap_item() */
       k=getch();
       if(27==k) {
          discardwin(win);
          return(NULL);
       }
       if(' '==k) break; /* Next page */
       if(allowPick && invlist && isalpha(k) && !isInvletterAvailable(k)) {
          discardwin(win);
          return(getItemByInvletter(k));
       }
       if(allowPick && !invlist && 'a'<=k && k<lastHeapItem) {
          discardwin(win);
          return(heapPointers[k-'a']);
       }
     }
     werase(win);wrefresh(win); /* blank it! */
     delwin(win); touchwin(stdscr);refresh();
     /* new page! */
     pageHead=pageBound;
   }
}


/* This will prolly never be used, as the odd characters don't seem to
be remotely portable. */
char arcanify(char n)
{
   if(n>='A'&&n<='Z') n-=('A'-'a'); /* to lowercase */
   if(n>='a'&&n<='z')
   {
      return(*("ߢef9hjk|Mn5+vWץZ"+(n-'a')));
   }
   return(n);
}

void apply_container(item_t *container)
{
   item_t *item;
   item_t *contents=container->Instdata.Container.Contents;
   char k; /* key */
   int openable=container->Itemtype->Typedata.Container.Opens;
   /* char *cname=container->Itemtype->Name; */
   char cname[80];
   char nstring[80]; /* for content items */
   describe_item(cname,container);
   if (openable) {
      sprintf(strbuf,"You open the %s,",cname);
      show_messages(strbuf);
   }
   /* if container's empty, ask if player wants to put something in.
   Else ask if they want to take something out, put something in, or
   do nothing. */
   if (contents==NULL) { /* empty */
      sprintf(strbuf,"The %s is empty. Do you want to put something in?",cname);
      show_messages(strbuf);
      k=getch();
      if(k!='y'&&k!='Y') {
        show_messages("OK, so don't.");
        return;
      }
      item=prompt_for_inv_item(0);
      if(NULL==item) { show_messages("Cancelled.");return;}
      if(item==container) { show_messages("That's STUPID!");return;}
      if (can_go_in_container(container,item)) {
        p_discard_item(item);
        put_in_container(container,item);
        describe_item(nstring,item);
        sprintf(strbuf,"You put the %s in the %s.",nstring,cname);
        show_messages(strbuf);
      }
   } else { /* Here we get a choice! */
      sprintf(strbuf,"There's something in the %s!",cname);
      show_messages(strbuf);
      sprintf(strbuf,"t: take something out. p: put something in. anything else: cancel");
      show_messages(strbuf);
      k=getch();
      switch(k) {
         case 't':
         case 'T':
           item=prompt_for_heap_item(contents);
           if(NULL==item) { show_messages("So don't then.");return;}
           remove_from_container(container,item);
           p_get_item(item); /* Not sure this is right. Meh. */
           describe_item(nstring,item);
           sprintf(strbuf,"You take the %s out of the %s.",nstring,cname);
           show_messages(strbuf);
           break;
         case 'p':
         case 'P':
           item=prompt_for_inv_item(0);
           if(NULL==item) { show_messages("Cancelled.");return;}
           if(item==container) { show_messages("That's STUPID!");return;}
           if (can_go_in_container(container,item)) {
             p_discard_item(item);
             put_in_container(container,item);
             describe_item(nstring,item);
             sprintf(strbuf,"You put the %s in the %s.",nstring,cname);
             show_messages(strbuf);
           }
           break;
         default:
           show_messages("OK.");
      }
   }
}
