/* ==== utils.c ==== */
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */


#include "porrog_defs.h"
 #include <stdio.h> /* printf */
#include <string.h>
#include <stddef.h>
#include <ctype.h>
#include "crash.h"

#if 0
void u64toa(char[] buf,uint64_t n) {
#else
char *u64toa(uint64_t n) {
   static char buf[21];
#endif
   int cpos;
   int dig; /* temporary var for digits */
   buf[20]='\0';/* Null terminator */
   for(cpos=20;(n>0&&cpos>0)||cpos==20/* If arg is 0, we should print it*/ ;){
      cpos--;
      dig=n%10;
      buf[cpos]=dig+'0';
      n= /* (*/ n /* -dig) */ /10;
   }
   if(n>0) {
      bugger(REPTYPE_CODE,LOGLEVEL_FOOBAR,"u64toa couldn't convert a number");
      crash(FUNCTION_ERROR);
   }
#if 1
   return(buf+cpos);
#else
   /* THIS WONT WORK FOR THIS CASE! */
#endif
}

int lastSpace(char *start, int length) {
   /* largely based on the space searching code in show_messages(), but
   more generalised pretty much, for use elsewhere */
   /* OBSERVATION:

    The code in show_messages didn't exactly return the location of the
    last space. Rather, it worked out where to end the line, which is
    NOT necessarily the same thing. Should fix this code accordingly,
    as regardless of the function's name, that is its ONLY real purpose */
   /* PURPOSE REDISCOVERED: returns the length of the string leading up
    to the last space, but not including it. IF the string is shorter than
    the given length, just return that length. */
   char *test;
   char *good;
   char *end;
   if(strlen(start)<length) /* return(0);
   -* HOLD ON! I know that it makes no sense to do searches for spaces if
   the available string will fit entirely in the available space...
   ...but that result makes no sense!!! Should PROBABLY be strlen(start)
   instead. But ATM I need to sleep. THINK HARD ABOUT THIS */ {
      return(strlen(start));
   }
   end=start+length;
   for(good=test=start;
     test!=NULL && test<end;
     good=test+1,test=strchr(good,' '));
   /* could be better, I expect... */
   if(good==NULL) {
      return(0); /* Under what circumstances is good==NULL? What is
                 the meaning of such a value? What should the behaviour
                 of the calling code be at such times? UNDECIDED!!! */
   } else {
     return((good-start)-1); /* probably... */
   }
}

void sprintempty(char *string) {
   *string='\0';
   /* mind-bogglingly complex, eh? ;)  But it avoids doing it with the
   sprintf functions, which is good generally, and it's more readable
   than doing the above everywhere. */
}
void stoupper(char *string) {
   /* performs toupper on a whole string up to the NULL */
   char *i=string;
   for(;*i!='\0';i++) {
      if(islower(*i)) (*i)-=32; /* depends on plain old 7 bit ASCII */
   }
   /* nothing to return- we operate on a buffer passed by the caller! */
}

/* ---end of utils.h --- */
