/* ==== item_p.h ==== */
/* START BOILERPLATE
   (=== a copyright notice to include everywhere, now by "boil.pl" ===)
   Part of the source of the program "Porrog", a roguelike game.
   Copyright (C) 2002-2004  Tom Barnes-Lawrence
   Current web address: www.angelfire.com/super2/duologue/software/porrog.html
   Current email address: tomble@usermail.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- END BOILERPLATE */


/*extern itemtype_t *first_it; */
/* Where do these get declared? HERE!*/
extern itemtype_t *first_its[]; /* Replaces the above */
extern int it_nums[]; /* The number of different types in each group */

extern unsigned int it_freqtot[]; /* total item frequencies for each group*/

extern item_t *phonyitem; /* prompt_for_inv_item() if player
 chooses '-' (whilst allowed) */

#ifdef MARK_INTERSECTIONS
extern itemtype_t *corner_marker;
#endif

/* include C-foogrid.h first, then maparray.h, before this. */

void i_init();
/* Creates all the item types. Only called once. */

void p_init_inv();
/* Sets up things like the inventory letter stuff */

char firstUnusedInvletter();
/* Returns the first letter available for use. Much more
   efficient than searching with isInvletterAvailable(). */
   /* RENAMED from first_unused_invletter() */

char isInvletterAvailable(char letter);
/* check availability of *specific* inventory letter */

void tagInvletterUsage(char letter,int discarding);
/* Sets that letter is or isn't available for use.
   If  discarding, letter becomes available.
   else isn't available any more. */
   /* RENAMED from tag_invletter_usage() */

item_t *getItemByInvletter(char letter);
/* scans through player inventory for item with given inventory
   letter. If item not found... crash??  Could have gone in player.c
   but it was practically on the toss of a coin. */

item_t *newItem(itemtype_t *otype,unsigned int quantity);
/* creates new instance of otype, unplaced, just returns pointer. */
/* RENAMED from new_item() */

void freeItem(item_t *item);
/* frees item, but if it's a container, frees contents first */
/* RENAMED from free_item() */

/* ----NO LONGER USED!!!! Use place_item(new_item()); etc instead---- *-
void add_item(levelstructs_t *level,int x, int y,itemtype_t *otype);
-* Places a new instance of otype at the position given. Finally removed. */

void newItemtype(itemtype_t *space,char symbol,pcolour_t col,char *name, itemgroup_t type, unsigned int weight, unsigned int probability);
/* Creates a new type of object, puts it into the space
   allocated by space. No extra space is allocated for name */
/* RENAMED from new_itemtype */

itemtype_t *push_itype(itemgroup_t group,char *name, unsigned int weight, unsigned int probability);
/* higher level function in creating item types. Places the newly
   created type on one of a global stack of items
   (one stack per group).
   Now also returns pointer to new itemtype. */

/* --- DOH, changed the semantics so name changed too! *-
int sameInventoryGroup(itemgroup_t grp1,itemgroup_t grp2);
-* returns 1 if grp1 and grp2 items will appear under the same
heading in the new inventory listings */

int sortInventoryGroup(itemgroup_t grp1,itemgroup_t grp2);
/* same semantics as perl's cmp and <=> operators: *0* if items will
appear under the smae heading in the new inventory listings... */

void itemGroupHeading(char *space,itemgroup_t group);
/* same semantics as describe_item(), etc, but for inventory groups */

itemtype_t *getItemtypeByProbability(itemgroup_t grp,unsigned int roll);
/* where 0 <= roll < (it_freqtot[grp]).
  Picks itemtype based on stored frequencies of the different items.
  Intended for use by add_room_items(), etc */

itemtype_t *getItemtypeByName(char *name,itemgroup_t grp);
/* Searches for itemtype with name. If finds one, returns it. Otherwise
returns NULL. If grp is given, only searches that group. If grp
is IG_LASTGROUP, searches them all. */
/* RENAMED from get_itemtype_by_name */

/*
item_t *skim_item(foogrid *map,int x,int y);
 Removes the top item from any heap on the floor. Returns that
   item alone (with item->Next==NULL) */
/* CHANGED TO: */
void skimItem(levelstructs_t *level, int x,int y,item_t *item);
/* Looks through the heap on the floor at x,y, finds item and
   removes it. If item isn't there (or there's no heap) CRASHES.
   It crashes? Really?
   Removes item from level-wide item list too. */
/* RENAMED from skim_item() */

void placeItem(levelstructs_t *level,int x,int y,item_t *item);
/* Puts a single item at a place on the floor. Adds it
   to level-wide item list too. */
/* RENAMED from place_item() */

item_t *nextItemByGroupThenList(item_t *head,item_t *current);
/* looks through items *following* current, to find items that would
 be listed after it when sorted first by group; if the next item in
 the list is from an earlier group, it doesn't count, etc.
 NB: Later had to add "head" parameter for start of the list, as
 there could be later items appearing after current :P */

void describe_item(char *space, item_t *item);
/* Gives the description (as in 57 arrows +1 or whatever) of item printed
   into space */

void item_basename(char *space,item_t *item);
/* Like the above, but would say arrow(s). Differs from just using
   item->Itemtype->Name, as this takes into account whether or not
   you know the item's real identity (eg clear potion VS potion of
   water). Would be used if you'll say "the", etc with it */


/* -- IS THIS EVEN THERE ANY MORE?? -- */
int combine_items(item_t *item, item_t *group);
/* If an item in group matches item in type, enchantment, egoness,
   and of course basic stackability (things like containers cant stack!)
   then simply adds the number of item to the number of the item found
   in group. At which point, I suppose item simply gets freed as
   two item structures get combined into 1.
   If the items weren't stackable, then item goes to the top of group
   instead.
   If the items were combined, return 1. If there was no combining
   then returns 0.
   This is important for when user picks up an item, as inventory
   letters get assigned to things.
   Ah, but what happens to the pointer to the group? If item goes
   on top, then the head pointer wants to be updated :P */

item_t *combinableItem(item_t *item,item_t *group);
/* DOH, this is what combine_items() should have been: It searches
   through "group" for something that COULD combine with "item",
   and if it finds one, it JUST RETURNS IT. It doesn't combine
   anything whatsoever, the caller must do that.
   Why? Because when you do ',' to pick something up, the program
   must know if you'll have enough inventory letters. If you can
   combine it with some other item, you will have enough, but
   otherwise you might not. As long as we have this function,
   it's simple(ish) to do the rest.*/

int isinclass(itemtype_t *type,itemclass_t cl);
/* Big switch statement. Returns 1 if type could fit in class cl */

